# 大搜车

## 前端

来源《[如何在大前端团队实现基建价值突破](https://mp.weixin.qq.com/s/C_Zu-eIFM3rIuFvJH8Y5sg)》

### 持续构建和持续部署

接下去介绍下我们再持续集成方面做的尝试，严格来说，我们提供的不是持续集成的流程最佳实践（团队太多，整个流程不急着标准化），而是持续构建和部署的能力。

这里面的复杂度主要是：

- 技术栈很多，Vue、React、React Native、iOS、Android、小程序、Node.js。
- 上层抹平技术栈
- 业务线和项目很多，前端项目接近 1000 个，RN 项目接近 300 个
- 打包资源要保证
- 构建部署方式需要标准化、集中化

最终，我们把所有无线的技术栈的集成流程做了抽象，每个技术栈的脚手架来适配，例如：

- 环境抽象（测试/稳定/预发等）
- 动作抽象（创建/打包/部署等）

然后把所有这些抽象到一个集中的服务中，提供出 PaaS 服务，上层只需要告诉我项目是什么技术栈，需要做什么动作，其他就可以不关心了，当然我们也有默认的上层最佳实践实现，但是业务也可以自己构建上层的持续集成流程。针对集中打包部署的性能问题，引入 tekton 集群流水线处理任务。

## 日志

来源《[日志收集系统在大搜车的探索和实践](https://www.infoq.cn/article/x09VV5CghhbLyr0hgb2R)》

```process-card
| 日志采集 | 日志处理 |日志存储 | 日志展示及应用(Job) |
|-|-|-|-|
| Flume  | Kafka | ElasticSearch | 报警中心 |
| | Flink | | 业务日志平台 |
| | | | 链路追踪 |
| | | | 监控报表 |
```
