# 农业银行

来源《[大型国有金融企业研发中心 DevOps 规划与实践](https://www.infoq.cn/article/493NdQc44E07TV2w1is5)》

## 建设思路

- 规范
  - 建立统一质量视图
  - 打造 DevOps 组织规范
- 流程
  - 构建持续交付流水线
  - 推进自动化测试
  - 完善运营监控
- 工具
  - 建设 DevOps 集成平台

## 工具

### DevOps 过程体系

```table-step

| 需求管理 | 计划与交付管理 | 配置管理 | 构建与持续集成 | 测试管理 | 代码质量 | 数据管理 | 环境管理 | 发布管理 | 部署管理 | 监控管理 | 事件管理 | 变更管理 | 运营一体化平台  |
|-|-|-|-|-|-|-|-|-|-|-|-|-|-|
| 需求下达 | 项目计划 | 版本控制 | 自动构建  | 自动化测试 | 代码复核 | 测试数据 | 环境管理 |制品管理 | 部署模式 | 指标采集 | 事件发现 | 普通变更 | 平台框架 |
| 条目化  | 需求交付 | 分支管理 | 持续集成 | 测试计划 | 静态检查  | 数据变更 |  | 单一数据源 | 部署流水线 | 数据处理 |事件处理 | 紧急变更  | PaaS 能力 |
| | 迭代计划 | | |  测试用例 | 漏洞扫描 | | |  | 异常识别| 事件回顾 | |
| | | | | 缺陷管理 | 单元测试 | | | | | 日志管理 | | |
| | | | | 准入准出 | | | | |  | 可视化及通知 | | |

config: { "rowHeight": "280px", "colors": [{"bg":"#e55852","font":"#b71a09"},{"bg":"#e98832","font":"#c85113"},{"bg":"#f0d668","font":"#b88d0f"},{"bg":"#a4c9cf","font":"#598893"},{"bg":"#47c0af","font":"#175a54"},{"bg":"#387fd5","font":"#9ac9f5"},{"bg":"#7753df","font":"#cbb5f8"},{"bg":"#00a2a1","font":"#3de8e7"},{"bg":"#f0d668","font":"#b88d0f"},{"bg":"#a4c9cf","font":"#598893"},{"bg":"#47c0af","font":"#175a54"},{"bg":"#387fd5","font":"#9ac9f5"},{"bg":"#f0d668","font":"#b88d0f"},{"bg":"#e98832","font":"#c85113"}]}
```

### DevOps 集成平台数据视图

```process-step
 - 管理数据
   - 基本项目信息
   - 需求
   - 项目计划
   - 测试预案
   - 测试准入信息
   - 测试准出信息
   - 资源信息
 - 开发数据
   - 需求条目
   - 交付计划
   - 迭代计划
   - 代码库信息
   - 分支信息
   - 版本信息
   - 制品信息
   - 集成策略
   - 构建策略
   - 代码合规检查配置信息
   - 单测配置信息
   - 测试计划
   - 测试部署策略
   - 用例信息
   - 缺陷信息
 - 运营数据
   - 事件问题信息
   - 变更单信息
   - 监控信息
   - 生产发布信息
```
