# 优酷

> 来源：《[提升研发效能没那么难，看优酷的最佳实践](https://mp.weixin.qq.com/s/lsdbUDabXYuHbpQ46ToFdQ)》

研发效能维度：

- 规范流程。与开发达成一致，形成文档，大家按照约定执行
- 数据驱动。通过收集各种数据反映研发效能问题，改进不足
- 自动化。把日常部分重复工作转化成自动化脚本，降低回归成本

中后期挑战：

- 流程规范靠约定，执行效果很难量化；执行完全依赖个人，约束力不强；
- 数据颗粒度比较粗，反应的问题比较片面；数据与研发流程脱节，很难形成驱动力；数据的收集成本也在持续增加；
- 自动化效果很难衡量；与研发流程脱节，关键节点依靠人来衔接，自动化的价值难以发挥。

## 优酷最佳实践

### 1. 提测流程平台化

```table-step
| 提测  | 提测通过 | 自动化任务 |
|-|-|-|
| 冒烟自动化 | 提测通知 |  稳定性测试|
|    | | 功能回归 |
| | | 性能回归 |
| | | ... |

config: { "rowHeight": "240px", "colors": [{"bg":"#e98832","font":"#c85113"},{"bg":"#f0d668","font":"#b88d0f"},{"bg":"#a4c9cf","font":"#598893"}]}
```

### 2. 移动端研发 Pipeline

### 流程

```table-step
| 需求阶段   | 开发/测试阶段 | 集成阶段 | 灰度/发布阶段 | 已发布阶段 |
|-|-|-|-|-|
|需求排期/评审  | 代码/用例设计 | 集成  | 灰度/发布| 运营 |
|     | 提测 | 验证| 验证  | 舆情 |
|    | 用例测试 | | | | 复盘 |

config: { "rowHeight": "230px", "colors": [{"bg":"#a4c9cf","font":"#598893"},{"bg":"#47c0af","font":"#175a54"},{"bg":"#387fd5","font":"#9ac9f5"},{"bg":"#7753df","font":"#cbb5f8"},{"bg":"#00a2a1","font":"#3de8e7"}]}
```

### 平台

```table-step
| 需求阶段   | 开发/测试阶段 | 集成阶段 | 灰度/发布阶段 | 已发布阶段 |
|-|-|-|-|-|
| 需求管理平台 | 提测平台 | 打包平台 | 灰度/发布平台 | 故障平台 |
| | 打包平台  |集成平台 | | 舆情平台 |
| | 自动化平台 | | | 复盘平台 |
| | 缺陷管理平台 | | |

config: { "rowHeight": "250px", "colors": [{"bg":"#f0d668","font":"#b88d0f"},{"bg":"#a4c9cf","font":"#598893"},{"bg":"#47c0af","font":"#175a54"},{"bg":"#387fd5","font":"#9ac9f5"},{"bg":"#7753df","font":"#cbb5f8"},{"bg":"#00a2a1","font":"#3de8e7"}]}
```

### 数据

```table-step
| 需求阶段   | 开发/测试阶段 | 集成阶段 | 灰度/发布阶段 | 已发布阶段 |
|-|-|-|-|-|
| 需求数据  | 需求进度 | 集成数据  | 灰度数据 | 舆情数据  |
| | 缺陷数据  | 缺陷数据 | 发布数据  | 故障数据  |
| | 提测数据  | | | 复盘数据 |

config: { "rowHeight": "210px", "colors": [{"bg":"#e55852","font":"#b71a09"},{"bg":"#e98832","font":"#c85113"},{"bg":"#f0d668","font":"#b88d0f"},{"bg":"#a4c9cf","font":"#598893"},{"bg":"#47c0af","font":"#175a54"},{"bg":"#387fd5","font":"#9ac9f5"},{"bg":"#7753df","font":"#cbb5f8"},{"bg":"#00a2a1","font":"#3de8e7"}]}
```

指标：

````mindmap
 - 数据
    - 质量
      - 结果
        - 故障
        - 回滚
        - 紧急集成
        - bugfix 集成
      - 过程
        - 一次集成 bug close 率
    - 效率
      - 结果
        - 需求吞吐率
        - 平均集成时长
      - 过程
        - bug 修复时长
        - bug 验证时长
        - 需求按时提测率
        - 提测通过率
```
````
