# 政采云

来源《[如何推动前端团队的基础设施建设](https://juejin.im/post/5e6db1da51882549076208da)》

### 基建搞什么
- 开发规范：这一部分沉淀的是团队的标准化共识，标准化是团队有效协作的必备前提。
- 研发流程：标准化流程直接影响上下游的协作分工和效率，优秀的流程能带来更专业的协作。
- 基础资产：在我们团队，资产体系包括了工具链、团队标准 DSL、物料库（组件、区块、模板等）。
- 工程管理：面向应用全生命周期的低成本管控，从应用的创建到本地环境配置到低代码搭建到打包部署。
- 性能体验：自动化工具化的方式发现页面性能瓶颈，提供优化建议。
- 安全防控：三方包依赖安全、代码合规性检查、安全风险检测等防控机制。
- 统计监控：埋点方案、数据采集、数据分析、线上异常监控等。
- 质量保障：自测 CheckList、单测、UI 自动化测试、链路自动化测试等。

### 基建怎么搞
1. 规范&文档（Docs）
2. 本地工程化环境（CLI）
3. 可视化工程系统（GUI）
4. 组件开发与管理
5. 模板开发与管理
6. 项目创建与管理
7. 前端基础资产
8. CI/CD 自动化构建部署
9. 可视化搭建系统
10. 数据埋点与分析
11. 页面性能自动化分析
