# 需求阿尔法的完整检查清单

《软件工程的本质：运用 SEMAT 内核》

```checklist
 - 需求阿尔法检查清单
   - 概念形成
     - 初始利益相关者同意开发新系统
     - 有可供新系统处理的新机会
     - 将要使用新系统的利益相关者已经确定
     - 资助新系统初始工作的利益相关者已经确定
   - 范围确定
     - 涉及开发新系统的利益相关者已经确定
     - 利益相关者同意新系统的目的
     - 评价新系统是否成功的标准已经清楚
     - 利益相关者对所提出的解决方案的范围达成共识
     - 描述需求的方式达成-致
     - 管理需求的机制已确定
     - 优先次序的规划是清楚的
     - 约束已确定并考虑成熟
     - 假定已经清晰规定
   - 具有一致性
     - 团队和利益相关者已经捕获和共享需求
     - 对需求的来源是清楚的
     - 需求背后的基本原理是清楚的
     - 冲突的需求已经确定和处理
     - 传达系统本质特征的需求已经交付
     - 系统最重要的使用场景已经被解释清楚
     - 需求的优先级是清楚的
     - 实施需求的影响已被理解
     - 团队理解什么需要交付，并且同意交付
   - 可接受的
     - 利益相关者接受需求描述一个可接受的解决方案
     - 一致同意需求的改变率是相对低的，而且是可控制的
     - 实施需求所产生的价值是清楚的
     - 由需求满足的机会部分是清楚的
   - 基本功能实现
     - 足够多的需求已被实现，使得利益相关者可以接受结果系统
     - 利益相关者接受需求精确地反映了系统该做什么和不该做什么
     - 已实现的需求项集合为利益相关者提供了清晰的价值
     - 利益相关者接受已实现需求的系统，认为其可以投人使用
   - 系统功能满足
     - 利益相关者接受需求，认为其精确地捕获了他们所要求的能够完全满足新系统需要的内容
     - 不再有阻止系统被接受为完全满足需求的需求项
     - 利益相关者接受系统为完全满足需求
```
