# 极限编程检查清单

```checklist
- 极限编程检查清单
  -  计划游戏 ( Planning Game )
    - 快速制定计划、随着细节的不断变化而完善；
  - 小型发布 ( Small Release )
    - 系统的设计要能够尽可能早地交付
  - 系统隐喻( System Metaphor )
    - 找到合适的比喻传达信息；
  - 简单设计( Simple Design )
    - 只处理当前的需求使设计保持简单；
  - 测试驱动( Test-driven )
    - 先写测试代码再编写程序；
  - 重构( Refactoring )
    - 重新审视需求和设计，重新明确地描述它们，以符合新的和现有的需求；
  - 结对编程( Pair Programming )
    - 由两个程序员在同一台电脑上共同编写解决同一问题的代码。
  - 集体所有权（Collective Ownership）
    - 任何人在任何时候都可以在系统中的任何位置更改任何代码。
  - 持续集成 ( Continuous Integration )
    - 可以按日甚至按小时为客户提供可运行的版本；
  - 每周工作40小时 ( 40-hour Week )
    - 要求项目团队人员每周工作时间不能超过 40 小时，加班不得连续超过两周，否则反而会影响生产率。
  - 现场客户 ( On-site Customer )
    - 在团队中加入一位真正的、起作用的用户，他将全职负责回答问题。
  - 编码标准( Code Standards )
    - 强调通过指定严格的代码规范来进行沟通，尽可能减少不必要的文档。
```
