# DevOps 技能图谱

```process-step
   - 学会一种编程语言
     - Node.js
     - Rust
     - Go
     - Java
     - Python
     - Ruby
     - C
     - C++
     - C#
   - 理解操作系统概念
     - 进程管理
     - 线程与并发
     - 套接字
     - POSIX 基础
     - 网络概念
     - 启动管理
     - 服务管理
     - I/O 管理
     - 虚拟化
     - 内存/存储
     - 文件系统
   - 学习管理服务器
     - 操作系统
       - Linux(各大发行版)
       - Unix(各大发行版)
       - Windows
     - 学会在终端操作
       - 文本处理工具
       - 进程监控
       - 网络
       - 学习 Bash 脚本
       - Vim/Nano/PowerShell/Emacs
       - 从源码编译程序
       - 系统性能
       - 其它命令
   - 网络、安全和协议
    - HTTP
    - HTTPS
    - FTP
    - SSL / TLS
    - SSH
    - 端口转发
   - 如何搭建一个__
    - 反向代理
    - 转发代理
    - 缓存服务器
    - 负载均衡
    - 防火墙
    - 网页服务器
      - IIS
      - Nginx
      - Apache
      - Tomcat
      - caddy
   - 学习基础设施即代码
     - 容器化
       - Docker
       - LXC
     - 配置管理
       - Ansible
       - Chef
       - Salt
       - Puppet
     - 容器编排
       - Kubernetes
       - Docker Swarm
       - Mesos
       - Nomad
     - 基础架构配置
       - Terraform
       - CloudFormation
       - Pulumi
     - 服务网格
       - Istio
       - Envoy
       - Linkerd
       - Consul
   - 学习 CI/CD 工具
    - Gitlab CI
    - Github Actions
    - Jenkins
    - Travis CI
    - CircleCI
    - TeamCity
    - Bamboo
    - Azure DevOps
   - 学习如何监控软件和基础架构
    - 基础架构监控
      - Prometheus
      - Grafana
      - Nagios
      - Zabbix
      - Monit
      - Datadog
    - Jaeger
      - New Relic
      - AppDynamics
      - Instana
      - OpenTracing
    - 日志管理
      - Elastic Stack
      - Graylog
      - Splunk
      - Papertrail
   - 云服务提供商
    - AWS
    - Digital Ocean
    - Google Cloud
    - Azure
    - Heroku
    - Alibaba Cloud
    - Linode
    - Vultr
   - 云设计模式
    - 可用性
    - 数据管理
    - 设计与设施
    - 管理与监控
```

```mindmap
 - DevOps 技能图谱
   - 学会一种编程语言
     - Node.js
     - Rust
     - Go
     - Java
     - Python
     - Ruby
     - C
     - C++
   - 理解操作系统概念
     - 进程管理
     - 线程与并发
     - 套接字
     - POSIX 基础
     - 网络概念
     - 启动管理
     - 服务管理
     - I/O 管理
     - 虚拟化
     - 内存/存储
     - 文件系统
   - 学习管理服务器
     - 操作系统
       - Linux(各大发行版)
       - Unix(各大发行版)
       - Windows
     - 学会在终端操作
       - 文本处理工具
       - 进程监控
       - 网络
       - 学习 Bash 脚本
       - Vim/Nano/PowerShell/Emacs
       - 从源码编译程序
       - 系统性能
       - 其它命令
   - 网络、安全和协议
    - HTTP
    - HTTPS
    - FTP
    - SSL / TLS
    - SSH
    - 端口转发
   - 如何搭建一个__
    - 反向代理
    - 转发代理
    - 缓存服务器
    - 负载均衡
    - 防火墙
    - 网页服务器
      - IIS
      - Nginx
      - Apache
      - Tomcat
      - caddy
   - 学习基础设施即代码
     - 容器化
       - Docker
       - LXC
     - 配置管理
       - Ansible
       - Chef
       - Salt
       - Puppet
     - 容器编排
       - Kubernetes
       - Docker Swarm
       - Mesos
       - Nomad
     - 基础架构配置
       - Terraform
       - CloudFormation
       - Pulumi
     - 服务网格
       - Istio
       - Envoy
       - Linkerd
       - Consul
   - 学习 CI/CD 工具
    - Gitlab CI
    - Github Actions
    - Jenkins
    - Travis CI
    - CircleCI
    - TeamCity
    - Bamboo
    - Azure DevOps
   - 学习如何监控软件和基础架构
    - 基础架构监控
      - Prometheus
      - Grafana
      - Nagios
      - Zabbix
      - Monit
      - Datadog
    - Jaeger
      - New Relic
      - AppDynamics
      - Instana
      - OpenTracing
    - 日志管理
      - Elastic Stack
      - Graylog
      - Splunk
      - Papertrail
   - 云服务提供商
    - AWS
    - Digital Ocean
    - Google Cloud
    - Azure
    - Heroku
    - Alibaba Cloud
    - Linode
    - Vultr
   - 云设计模式
    - 可用性
    - 数据管理
    - 设计与设施
    - 管理与监控
```

```sunburst
 - DevOps 技能图谱
   - 学会一种编程语言
     - Node.js
     - Rust
     - Go
     - Java
     - Python
     - Ruby
     - C
     - C++
   - 理解操作系统概念
     - 进程管理
     - 线程与并发
     - 套接字
     - POSIX 基础
     - 网络概念
     - 启动管理
     - 服务管理
     - I/O 管理
     - 虚拟化
     - 内存/存储
     - 文件系统
   - 学习管理服务器
     - 操作系统
       - Linux(各大发行版)
       - Unix(各大发行版)
       - Windows
     - 学会在终端操作
       - 文本处理工具
       - 进程监控
       - 网络
       - 学习 Bash 脚本
       - Vim/Nano/PowerShell/Emacs
       - 从源码编译程序
       - 系统性能
       - 其它命令
   - 网络、安全和协议
    - HTTP
    - HTTPS
    - FTP
    - SSL / TLS
    - SSH
    - 端口转发
   - 如何搭建一个__
    - 反向代理
    - 转发代理
    - 缓存服务器
    - 负载均衡
    - 防火墙
    - 网页服务器
      - IIS
      - Nginx
      - Apache
      - Tomcat
      - caddy
   - 学习基础设施即代码
     - 容器化
       - Docker
       - LXC
     - 配置管理
       - Ansible
       - Chef
       - Salt
       - Puppet
     - 容器编排
       - Kubernetes
       - Docker Swarm
       - Mesos
       - Nomad
     - 基础架构配置
       - Terraform
       - CloudFormation
       - Pulumi
     - 服务网格
       - Istio
       - Envoy
       - Linkerd
       - Consul
   - 学习 CI/CD 工具
    - Gitlab CI
    - Github Actions
    - Jenkins
    - Travis CI
    - CircleCI
    - TeamCity
    - Bamboo
    - Azure DevOps
   - 学习如何监控软件和基础架构
    - 基础架构监控
      - Prometheus
      - Grafana
      - Nagios
      - Zabbix
      - Monit
      - Datadog
    - Jaeger
      - New Relic
      - AppDynamics
      - Instana
      - OpenTracing
    - 日志管理
      - Elastic Stack
      - Graylog
      - Splunk
      - Papertrail
   - 云服务提供商
    - AWS
    - Digital Ocean
    - Google Cloud
    - Azure
    - Heroku
    - Alibaba Cloud
    - Linode
    - Vultr
   - 云设计模式
    - 可用性
    - 数据管理
    - 设计与设施
    - 管理与监控
```
