# CODING DevOps 平台

[CODING DevOps](https://coding.net) 提供全套 DevOps 解决方案，让团队在云端高效协同、在开发协作过程中享受极致体验，提升软件交付质量与速度。
![图片](https://md-1253923140.cos.ap-shenzhen-fsi.myqcloud.com/DevOps.png)

# 为您解决研发管理上的难题

## 完整 DevOps 解决方案

提供整套工具+线上培训的 DevOps 升级方案，并设有专业的合作伙伴为您提供驻场顾问咨询、企业培训、敏捷及 DevOps 成熟度评估。

## 灵活的服务方式

客户可依据自身技术特性、DevOps 成熟度及合规性的需求，灵活选配公/私有云服务，标准化/定制化产品，咨询培训服务。

## 研发和协作工具一体化

研发、产品、设计、测试不同岗位无缝协作，避免跨多个平台协作管理，降低沟通成本。

## 适合中国团队的敏捷实践

规划迭代、细分需求、进度把控，帮助管理者实行精细化管理，解决协作杂乱无序状态。

## 测试开发协同快速修复缺陷

高频率持续集成快速暴露缺陷，自动化测试手段以及专业的人工测试管理软件协助测试与开发流畅协同，提升软件质量。

## 强大的权限及审批系统降低安全风险

自定义的发布审批流程，细粒度的权限功能管理，最大限度的降低企业代码和业务的安全风险。

# 一站式 DevOps 解决方案

## 团队无缝协作

![图片](https://assets.codehub.cn/images/requirement.bb96537d.jpg)

#### 建立有序的迭代计划

按优先级拖拉事务建立迭代计划，增量式迭代帮助团队在最短时间内交付最大价值产品。

#### 灵活的事项交付过程

需求、任务的分解和管理，设计最符合团队内开发、产品、设计等不同岗位协作的流转过程。

#### 直观的看板视图

查看看板中的事项状态，直观高效跟踪迭代日常进展，团队计划会议的最佳辅助。

## 高效管理代码

![图片](https://assets.codehub.cn/images/code-review.1a33a95d.jpg)

#### 全面支持 Git/SVN

同时支持 Git/原生 SVN 两种常见版本控制工具，满足不同团队的使用习惯。

#### 建立代码评审机制

分支粒度管理和逐行代码评论帮助团队建立良好的代码审查机制，提高研发生产安全性、高效性。

#### 自动化版本管理

发布代码即自动生成 ChangLog，规范版本号，让源码发布和交付标准高效。

## 高频率持续集成

![图片](https://assets.codehub.cn/images/ci.fa9c8240.jpg)

#### 自动化构建测试

每次提交的代码即进行自动化的代码检查、编译构建，配合保护分支策略，保障主干代码可靠。

#### 丰富的构建模板

预置丰富的构建模板和第一方插件，协助团队低成本实践 DevOps。

#### 灵活的构建资源选择

提供高性能构建资源，便捷的开启持续集成，同时也支持用户接入第三方构建机，满足特定场景下的构建需求。

## 井然有序的制品管理

![图片](https://assets.codehub.cn/images/artifact.58307620.jpg)

#### 多种制品的类型支持

支持包括 Docker、Maven、npm、Genric、Pypi、Helm 等九种制品库类型。

#### 第三方制品统一管理

支持制品代理，统一管理团队内的制品源，保障制品安全可追溯

#### 自定义版本覆盖策略

保障制品的唯一性，灵活的版本覆盖策略使制品在开发 / 测试 / 生产流转更加有序

## 自动可控的持续部署

![图片](https://md-1253923140.cos.ap-shenzhen-fsi.myqcloud.com/%E4%BC%81%E4%B8%9A%E5%BE%AE%E4%BF%A1%E6%88%AA%E5%9B%BE_d7b4090f-0cdd-4027-9b11-283d439da864.png)

#### 灵活的发布流程编排

方便的实现蓝绿发布、灰度发布、滚动发布、快速回滚等能力。

#### 全流程管控

全面打通上下游信息，

#### 云原生快速部署

支持腾讯云 TKE 容器服务、SCF 云函数、CVM 云服务器、Kubernetes 集群等的快速部署。

# 多重措施保障数据安全

![图片](https://md-1253923140.cos.ap-shenzhen-fsi.myqcloud.com/Xnip2020-04-08_22-10-50.jpg)
