# 需求管理

## 敏捷需求分析

### 需求新定义

需求是**“建立在商业、技术和人之间的一组动态的、待验证的假设”**；<br>
挖掘和定义需求的过程，是一个不断验证假设、在试错中学习、逐步逼近直至找到与市场的“契合点”的过程。

### 需求工作的挑战

- 挑战之一: 需求产生时的“不确定性”。
- 挑战之二: 需求经过层层分解可能完全失去原有意图。
- 挑战之三: 需求实现所必须的社会化协作导致的需求失真、或被“污染”。
- 挑战之四：需求的时效性。在验证假设的过程中，外部市场时刻发生着变化。

### 敏捷需求分析

## 核心实践

### MVP 思想

### 用户故事和 INVEST

#### 用户故事

作为一个 [角色] <br>
我想要 [功能] <br>
以便于 [价值] <br>

#### INVEST 原则

- 独立的（Independent）
- 可讨论的（Negotiable）
- 有价值的（Valuable）
- 可估算的（Estimable）
- 小的（Small）
- 可测试的（Testable）

### 需求拆分方法和原则

- 拆分方法：

1. 工作流系统：横切和纵切；
1. 按功能模块：按业务规则拆分、1+N 模式；
1. 复杂业务模型：按照实际需要提供的功能来拆分。

- 拆分原则：

1. 满足 Invest 原则；
1. 80/20 原则：价值先行；
1. 风险高的需要端到端切分；
1. 纵向拆分需求促进持续交付；
1. 其他：易懂、抽象、逻辑性、可验收、MECE 等。

### 实例化需求

### 需求工具集

## 需求交付

### 需求估算

### 优先级排序

### 风险管理

### 演示和反馈
